SCRIPT_DIR=$(dirname "${BASH_SOURCE[0]}")

source "$SCRIPT_DIR/package_manager_identifiers.sh"

# APT packages
APT_GIT_PACKAGE="$APT_IDENTIFIER:git"
APT_DOCKER_CE_PACKAGE="$APT_IDENTIFIER:docker-ce"
APT_VIRTUALBOX_PACKAGE="$APT_IDENTIFIER:virtualbox"
APT_VLC_PACKAGE="$APT_IDENTIFIER:vlc"
APT_NET_TOOLS_PACKAGE="$APT_IDENTIFIER:net-tools"
APT_DL_DRIVER_PACKAGE="$APT_IDENTIFIER:dl-driver"
APT_PROTONVPN_PACKAGE="$APT_IDENTIFIER:proton-vpn"
APT_WIREGUARDVPN_PACKAGE="$APT_IDENTIFIER:wireguard"
APT_DCONF_EDITOR="$APT_IDENTIFIER:dconf-editor"

APT_GIT_PACKAGE_DISPLAY_NAME="Git"
APT_DOCKER_CE_PACKAGE_DISPLAY_NAME="Docker Community Edition"
APT_VIRTUALBOX_PACKAGE_DISPLAY_NAME="VirtualBox"
APT_VLC_PACKAGE_DISPLAY_NAME="VLC Media Player"
APT_NET_TOOLS_PACKAGE_DISPLAY_NAME="net-tools"
APT_DL_DRIVER_PACKAGE_DISPLAY_NAME="DisplayLink Driver"
APT_PROTONVPN_PACKAGE_DISPLAY_NAME="ProtonVPN"
APT_WIREGUARDVPN_PACKAGE_DISPLAY_NAME="WireGuard VPN"
APT_DCONF_EDITOR_DISPLAY_NAME="DConf Editor"

# Snap packages
SNAP_VSCODE_PACKAGE="$SNAP_IDENTIFIER:vscode"
SNAP_RIDER_PACKAGE="$SNAP_IDENTIFIER:rider"
SNAP_KUBECTL_PACKAGE="$SNAP_IDENTIFIER:kubectl"
SNAP_FIREFOX_PACKAGE="$SNAP_IDENTIFIER:firefox"

SNAP_VSCODE_PACKAGE_DISPLAY_NAME="Visual Studio Code"
SNAP_RIDER_PACKAGE_DISPLAY_NAME="JetBrains Rider"
SNAP_KUBECTL_PACKAGE_DISPLAY_NAME="kubectl"
SNAP_FIREFOX_PACKAGE_DISPLAY_NAME="Firefox"

# Flatpak packages
FLATPAK_IDEA_COMMUNITY_PACKAGE="$FLATPAK_IDENTIFIER:intellij-idea-community"
FLATPAK_WEBSTORM_PACKAGE="$FLATPAK_IDENTIFIER:webstorm"
FLATPAK_ANDROID_STUDIO_PACKAGE="$FLATPAK_IDENTIFIER:android-studio"
FLATPAK_OBSIDIAN_PACKAGE="$FLATPAK_IDENTIFIER:obsidian"
FLATPAK_SPOTIFY_PACKAGE="$FLATPAK_IDENTIFIER:spotify"
FLATPAK_GIMP_PACKAGE="$FLATPAK_IDENTIFIER:gimp"
FLATPAK_FLAMESHOT_PACKAGE="$FLATPAK_IDENTIFIER:flameshot"
FLATPAK_NEXTCLOUD_CLIENT_PACKAGE="$FLATPAK_IDENTIFIER:nextcloud-client"
FLATPAK_FLATSEAL_PACKAGE="$FLATPAK_IDENTIFIER:flatseal"
FLATPAK_REMMINA_PACKAGE="$FLATPAK_IDENTIFIER:remmina"

FLATPAK_IDEA_COMMUNITY_PACKAGE_DISPLAY_NAME="JetBrains IntelliJ IDEA Community"
FLATPAK_WEBSTORM_PACKAGE_DISPLAY_NAME="JetBrains WebStorm"
FLATPAK_ANDROID_STUDIO_PACKAGE_DISPLAY_NAME="Android Studio"
FLATPAK_OBSIDIAN_PACKAGE_DISPLAY_NAME="Obsidian"
FLATPAK_SPOTIFY_PACKAGE_DISPLAY_NAME="Spotify"
FLATPAK_GIMP_PACKAGE_DISPLAY_NAME="GIMP"
FLATPAK_FLAMESHOT_PACKAGE_DISPLAY_NAME="Flameshot"
FLATPAK_NEXTCLOUD_CLIENT_PACKAGE_DISPLAY_NAME="Nextcloud Client"
FLATPAK_FLATSEAL_PACKAGE_DISPLAY_NAME="Flatseal"
FLATPAK_REMMINA_PACKAGE_DISPLAY_NAME="Remmina"

# Raw packages
RAW_GITEXTENSIONS_PACKAGE="$RAW_IDENTIFIER:gitextensions"
RAW_K3D_PACKAGE="$RAW_IDENTIFIER:k3d"
RAW_JAN_PACKAGE="$RAW_IDENTIFIER:jan"

RAW_GITEXTENSIONS_PACKAGE_DISPLAY_NAME="GitExtensions"
RAW_K3D_PACKAGE_DISPLAY_NAME="k3d"
RAW_JAN_PACKAGE_DISPLAY_NAME="Jan Local AI Assistant"

# Mainline kernel
MAINLINE_KERNEL_PACKAGE="$MAINLINE_KERNEL_IDENTIFIER"

MAINLINE_KERNEL_PACKAGE_DISPLAY_NAME="Mainline Kernel"

# Packages dictionary
declare -A PACKAGES
PACKAGES=(
    ["$SNAP_VSCODE_PACKAGE"]="$SNAP_VSCODE_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_IDEA_COMMUNITY_PACKAGE"]="$FLATPAK_IDEA_COMMUNITY_PACKAGE_DISPLAY_NAME"
    ["$SNAP_RIDER_PACKAGE"]="$SNAP_RIDER_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_WEBSTORM_PACKAGE"]="$FLATPAK_WEBSTORM_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_ANDROID_STUDIO_PACKAGE"]="$FLATPAK_ANDROID_STUDIO_PACKAGE_DISPLAY_NAME"
    ["$APT_GIT_PACKAGE"]="$APT_GIT_PACKAGE_DISPLAY_NAME"
    ["$RAW_GITEXTENSIONS_PACKAGE"]="$RAW_GITEXTENSIONS_PACKAGE_DISPLAY_NAME"
    ["$APT_DOCKER_CE_PACKAGE"]="$APT_DOCKER_CE_PACKAGE_DISPLAY_NAME"
    ["$RAW_K3D_PACKAGE"]="$RAW_K3D_PACKAGE_DISPLAY_NAME"
    ["$SNAP_KUBECTL_PACKAGE"]="$SNAP_KUBECTL_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_OBSIDIAN_PACKAGE"]="$FLATPAK_OBSIDIAN_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_SPOTIFY_PACKAGE"]="$FLATPAK_SPOTIFY_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_GIMP_PACKAGE"]="$FLATPAK_GIMP_PACKAGE_DISPLAY_NAME"
    ["$APT_VIRTUALBOX_PACKAGE"]="$APT_VIRTUALBOX_PACKAGE_DISPLAY_NAME"
    ["$APT_VLC_PACKAGE"]="$APT_VLC_PACKAGE_DISPLAY_NAME"
    ["$APT_NET_TOOLS_PACKAGE"]="$APT_NET_TOOLS_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_FLAMESHOT_PACKAGE"]="$FLATPAK_FLAMESHOT_PACKAGE_DISPLAY_NAME"
    ["$APT_DL_DRIVER_PACKAGE"]="$APT_DL_DRIVER_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_NEXTCLOUD_CLIENT_PACKAGE"]="$FLATPAK_NEXTCLOUD_CLIENT_PACKAGE_DISPLAY_NAME"
    ["$APT_PROTONVPN_PACKAGE"]="$APT_PROTONVPN_PACKAGE_DISPLAY_NAME"
    ["$APT_WIREGUARDVPN_PACKAGE"]="$APT_WIREGUARDVPN_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_FLATSEAL_PACKAGE"]="$FLATPAK_FLATSEAL_PACKAGE_DISPLAY_NAME"
    ["$FLATPAK_REMMINA_PACKAGE"]="$FLATPAK_REMMINA_PACKAGE_DISPLAY_NAME"
    ["$SNAP_FIREFOX_PACKAGE"]="$SNAP_FIREFOX_PACKAGE_DISPLAY_NAME"
    ["$MAINLINE_KERNEL_PACKAGE"]="$MAINLINE_KERNEL_PACKAGE_DISPLAY_NAME"
    ["$APT_DCONF_EDITOR"]="$APT_DCONF_EDITOR_DISPLAY_NAME"
    ["$RAW_JAN_PACKAGE"]="$RAW_JAN_PACKAGE_DISPLAY_NAME"
)

ORDERED_PACKAGES=( # Needed when order matters
    "$SNAP_VSCODE_PACKAGE"
    "$FLATPAK_IDEA_COMMUNITY_PACKAGE"
    "$SNAP_RIDER_PACKAGE"
    "$FLATPAK_WEBSTORM_PACKAGE"
    "$FLATPAK_ANDROID_STUDIO_PACKAGE"
    "$APT_GIT_PACKAGE"
    "$RAW_GITEXTENSIONS_PACKAGE"
    "$APT_DOCKER_CE_PACKAGE"
    "$RAW_K3D_PACKAGE"
    "$SNAP_KUBECTL_PACKAGE"
    "$SNAP_FIREFOX_PACKAGE"
    "$FLATPAK_OBSIDIAN_PACKAGE"
    "$FLATPAK_SPOTIFY_PACKAGE"
    "$FLATPAK_GIMP_PACKAGE"
    "$APT_VIRTUALBOX_PACKAGE"
    "$APT_VLC_PACKAGE"
    "$APT_NET_TOOLS_PACKAGE"
    "$FLATPAK_FLAMESHOT_PACKAGE"
    "$APT_DL_DRIVER_PACKAGE"
    "$FLATPAK_NEXTCLOUD_CLIENT_PACKAGE"
    "$APT_PROTONVPN_PACKAGE"
    "$APT_WIREGUARDVPN_PACKAGE"
    "$FLATPAK_FLATSEAL_PACKAGE"
    "$FLATPAK_REMMINA_PACKAGE"
    "$APT_DCONF_EDITOR"
    "$RAW_JAN_PACKAGE"
    "$MAINLINE_KERNEL_PACKAGE"
)
